﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using ThinkGeo.MapSuite.Core;

namespace TestShapeFile
{
    public class MyManagedProj4Projection : ManagedProj4Projection
    {
        private double m_HalfWorldWidth = 20026376.3937099;

        public MyManagedProj4Projection()
            : base()
        {

        }
        public MyManagedProj4Projection(double halfWorldWidth)
            : base()
        {
            m_HalfWorldWidth = halfWorldWidth;


        }
        protected override Vertex[] ConvertToInternalProjectionCore(double[] x, double[] y)
        {
            for (int i = 0; i < x.Length; i++)
            {

                if (x[i] < -20037508.2314698)
                {

                    x[i] = -20037508.2314698;

                }

                if (x[i] > 20037508.2314698)
                {

                    x[i] = 20037508.2314698;

                }

            }

            return base.ConvertToInternalProjectionCore(x, y);

            //for (int i = 0; i < x.Length; i++)
            //{
            //    if (x[i] < -m_HalfWorldWidth)
            //    {
            //        x[i] = -m_HalfWorldWidth;
            //    }
            //    if (x[i] > m_HalfWorldWidth)
            //    {
            //        x[i] = m_HalfWorldWidth;
            //    }
            //}

            //return base.ConvertToInternalProjectionCore(x, y);
        }
    }
}
